import type { Ref, ComputedRef } from 'vue';
import type { InjectionKey } from 'vue';
export interface ScrollbarContext {
    className: string;
    hashId: Ref<string>;
    scrollbarElement: Ref<HTMLDivElement | undefined>;
    wrapElement: Ref<HTMLDivElement | undefined>;
    [key: string]: any;
}
export declare const scrollbarContextKey: InjectionKey<ScrollbarContext>;
export type ContextType = any;
export declare const useContext: <T>(contextInjectKey?: string | InjectionKey<ContextType>, defaultValue?: ContextType) => T;
export declare const provideScrollBarContext: (value: ScrollbarContext | ComputedRef<ScrollbarContext>) => void;
export declare const useScrollBarContext: () => Required<ScrollbarContext>;
