import type { CSSProperties, PropType } from 'vue';
export declare const scrollbarProps: {
    /**
     * @description height of scrollbar
     */
    height: {
        type: (StringConstructor | NumberConstructor)[];
        default: string;
    };
    /**
     * @description max height of scrollbar
     */
    maxHeight: {
        type: (StringConstructor | NumberConstructor)[];
        default: string;
    };
    /**
     * @description whether to use the native scrollbar
     */
    native: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * @description style of wrap
     */
    barStyle: {
        type: PropType<string | CSSProperties>;
        default: string;
    };
    wrapStyle: {
        type: PropType<string | CSSProperties>;
        default: string;
    };
    /**
     * @description class of wrap
     */
    wrapClass: {
        type: (StringConstructor | ArrayConstructor)[];
        default: string;
    };
    /**
     * @description class of view
     */
    viewClass: {
        type: (StringConstructor | ArrayConstructor)[];
        default: string;
    };
    /**
     * @description style of view
     */
    viewStyle: {
        type: PropType<string | CSSProperties>;
        default: string;
    };
    /**
     * @description do not respond to container size changes, if the container size does not change, it is better to set it to optimize performance
     */
    noresize: BooleanConstructor;
    /**
     * @description element tag of the view
     */
    tag: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @description always show
     */
    always: BooleanConstructor;
    /**
     * @description minimum size of scrollbar
     */
    minSize: {
        type: NumberConstructor;
        default: number;
    };
};
export declare const scrollbarEmits: {
    scroll: ({ scrollTop, scrollLeft }: {
        scrollTop: number;
        scrollLeft: number;
    }) => boolean;
};
