import { isNumber as w, isString as G, getPrefixCls as U, isObject as q } from "@gx-design-vue/pro-utils";
import { provide as V, inject as _, defineComponent as Y, ref as f, computed as L, onBeforeUnmount as J, watch as A, createVNode as b, Transition as Q, withDirectives as Z, vShow as p, Fragment as ee, nextTick as j, onMounted as te } from "vue";
import { useEventListener as W, isClient as le, useResizeObserver as D } from "@vueuse/core";
import { getTransitionProps as ae, Keyframe as K, useProStyle as oe } from "@gx-design-vue/pro-provider";
const ne = {
  /**
   * @description height of scrollbar
   */
  height: {
    type: [String, Number],
    default: ""
  },
  /**
   * @description max height of scrollbar
   */
  maxHeight: {
    type: [String, Number],
    default: ""
  },
  /**
   * @description whether to use the native scrollbar
   */
  native: {
    type: Boolean,
    default: !1
  },
  /**
   * @description style of wrap
   */
  barStyle: {
    type: [Object, String],
    default: ""
  },
  wrapStyle: {
    type: [Object, String],
    default: ""
  },
  /**
   * @description class of wrap
   */
  wrapClass: {
    type: [String, Array],
    default: ""
  },
  /**
   * @description class of view
   */
  viewClass: {
    type: [String, Array],
    default: ""
  },
  /**
   * @description style of view
   */
  viewStyle: {
    type: [Object, String],
    default: ""
  },
  /**
   * @description do not respond to container size changes, if the container size does not change, it is better to set it to optimize performance
   */
  noresize: Boolean,
  /**
   * @description element tag of the view
   */
  tag: {
    type: String,
    default: "div"
  },
  /**
   * @description always show
   */
  always: Boolean,
  /**
   * @description minimum size of scrollbar
   */
  minSize: {
    type: Number,
    default: 20
  }
}, ie = {
  scroll: ({ scrollTop: e, scrollLeft: s }) => w(e) && w(s)
}, F = Symbol("scrollbarContextKey"), re = (e = Symbol(), s) => _(e, s || {}), se = (e) => {
  V(F, e);
}, ue = () => re(F, {}), ce = {
  always: {
    type: Boolean,
    default: !0
  },
  width: String,
  height: String,
  ratioX: {
    type: Number,
    default: 1
  },
  ratioY: {
    type: Number,
    default: 1
  },
  barStyle: {
    type: [Object, String],
    default: ""
  }
}, fe = {
  vertical: Boolean,
  size: String,
  move: Number,
  ratio: {
    type: Number,
    required: !0
  },
  always: Boolean,
  barStyle: {
    type: [Object, String],
    default: ""
  }
}, ve = {
  vertical: {
    offset: "offsetHeight",
    scroll: "scrollTop",
    scrollSize: "scrollHeight",
    size: "height",
    key: "vertical",
    axis: "Y",
    client: "clientY",
    direction: "top"
  },
  horizontal: {
    offset: "offsetWidth",
    scroll: "scrollLeft",
    scrollSize: "scrollWidth",
    size: "width",
    key: "horizontal",
    axis: "X",
    client: "clientX",
    direction: "left"
  }
}, de = (e) => G(e) ? !Number.isNaN(Number(e)) : !1, me = ({ move: e, size: s, bar: n }) => ({
  [n.size]: s,
  transform: `translate${n.axis}(${e}%)`
});
function I(e, s = "px") {
  if (!e)
    return "";
  if (w(e) || de(e))
    return `${e}${s}`;
  if (G(e))
    return e;
  console.warn("utils/dom/style", "value 必须为数字");
}
const X = /* @__PURE__ */ Y({
  props: fe,
  setup(e) {
    const {
      hashId: s,
      wrapElement: n,
      scrollbarElement: g,
      className: y
    } = ue(), i = f(), u = f(), m = f({}), r = f(!1);
    let v = !1, x = !1, a = le ? document.onselectstart : null;
    const l = L(() => ve[e.vertical ? "vertical" : "horizontal"]), T = L(() => me({
      size: e.size,
      move: e.move,
      bar: l.value
    })), z = L(() => (
      // offsetRatioX = original width of thumb / current width of thumb / ratioX
      // offsetRatioY = original height of thumb / current height of thumb / ratioY
      // instance height = wrap height - GAP
      i.value[l.value.offset] ** 2 / n.value[l.value.scrollSize] / ((e == null ? void 0 : e.ratio) || 0) / u.value[l.value.offset]
    )), C = (o) => {
      var c;
      if (o.stopPropagation(), o.ctrlKey || [1, 2].includes(o.button))
        return;
      (c = window.getSelection()) == null || c.removeAllRanges(), N(o);
      const h = o.currentTarget;
      h && (m.value[l.value.axis] = h[l.value.offset] - (o[l.value.client] - h.getBoundingClientRect()[l.value.direction]));
    }, P = (o) => {
      if (!u.value || !i.value || !n.value)
        return;
      const h = Math.abs(o.target.getBoundingClientRect()[l.value.direction] - o[l.value.client]), c = u.value[l.value.offset] / 2, t = (h - c) * 100 * z.value / i.value[l.value.offset];
      n.value[l.value.scroll] = t * n.value[l.value.scrollSize] / 100;
    }, N = (o) => {
      o.stopImmediatePropagation(), v = !0, document.addEventListener("mousemove", H), document.addEventListener("mouseup", S), a = document.onselectstart, document.onselectstart = () => !1;
    }, H = (o) => {
      if (!i.value || !u.value || v === !1)
        return;
      const h = m.value[l.value.axis];
      if (!h)
        return;
      const c = (i.value.getBoundingClientRect()[l.value.direction] - o[l.value.client]) * -1, t = u.value[l.value.offset] - h, d = (c - t) * 100 * z.value / i.value[l.value.offset];
      n.value[l.value.scroll] = d * n.value[l.value.scrollSize] / 100;
    }, S = () => {
      v = !1, m.value[l.value.axis] = 0, document.removeEventListener("mousemove", H), document.removeEventListener("mouseup", S), $(), x && (r.value = !1);
    }, M = () => {
      x = !1, r.value = !!e.size;
    }, B = () => {
      x = !0, r.value = v;
    };
    J(() => {
      $(), document.removeEventListener("mouseup", S);
    });
    const $ = () => {
      document.onselectstart !== a && (document.onselectstart = a);
    };
    return A(() => g.value, (o) => {
      W(o, "mousemove", M), W(o, "mouseleave", B);
    }), () => {
      const o = ae(`${y}-fade`);
      return b(Q, o, {
        default: () => [Z(b("div", {
          ref: i,
          style: e.barStyle,
          class: [`${y}-bar`, "is-" + l.value.key, s.value],
          onMousedown: P
        }, [b("div", {
          ref: u,
          class: `${y}-thumb ${s.value}`,
          style: T.value,
          onMousedown: C
        }, null)]), [[p, e.always || r.value]])]
      });
    };
  }
});
X.inheritAttrs = !1;
const he = /* @__PURE__ */ Y({
  inheritAttrs: !1,
  props: ce,
  setup(e, {
    expose: s
  }) {
    const n = f(0), g = f(0), y = 4;
    return s({
      handleScroll: (u) => {
        if (u) {
          const m = u.offsetHeight - y, r = u.offsetWidth - y;
          g.value = u.scrollTop * 100 / m * e.ratioY, n.value = u.scrollLeft * 100 / r * e.ratioX;
        }
      }
    }), () => b(ee, null, [b(X, {
      move: n.value,
      barStyle: e.barStyle,
      ratio: e.ratioX,
      size: e.width,
      always: e.always
    }, null), b(X, {
      move: g.value,
      barStyle: e.barStyle,
      ratio: e.ratioY,
      size: e.height,
      vertical: !0,
      always: e.always
    }, null)]);
  }
}), be = new K("fadeIn", {
  "0%": {
    opacity: 0
  },
  "100%": {
    opacity: 1
  }
}), ge = new K("fadeOut", {
  "0%": {
    opacity: 1
  },
  "100%": {
    opacity: 0
  }
}), ye = (e) => ({
  [`${e.componentCls}`]: {
    position: "relative",
    height: "100%",
    overflow: "hidden",
    ["&-wrap"]: {
      height: "100%",
      overflow: "auto",
      ["&-hidden-default"]: {
        scrollbarWidth: "none",
        ["&::-webkit-scrollbar"]: {
          display: "none"
        }
      }
    },
    ["&-bar"]: {
      position: "absolute",
      right: 2,
      bottom: 2,
      zIndex: 1,
      borderRadius: 4,
      ["&.is-vertical"]: {
        top: 2,
        width: 6,
        ["& > div"]: {
          width: "100%"
        }
      },
      ["&.is-horizontal"]: {
        left: 2,
        height: 6,
        ["& > div"]: {
          height: "100%"
        }
      }
    },
    ["&-thumb"]: {
      position: "relative",
      display: "block",
      width: 0,
      height: 0,
      cursor: "pointer",
      backgroundColor: "rgba(0, 0, 0, 0.25)",
      borderRadius: e.borderRadius,
      transition: ".3s background-color",
      ["&:hover"]: {
        backgroundColor: "rgba(0, 0, 0, 0.4)"
      }
    },
    ["&-fade-appear, &-fade-enter"]: {
      animationName: be,
      animationDuration: ".34s",
      animationTimingFunction: "ease-out"
    },
    ["&-fade-leave"]: {
      animationName: ge,
      animationDuration: ".34s",
      animationTimingFunction: "ease-out"
    }
  }
}), Se = /* @__PURE__ */ Y({
  name: "GScrollbars",
  props: ne,
  emits: ie,
  setup(e, {
    emit: s,
    slots: n,
    attrs: g,
    expose: y
  }) {
    const i = U({
      suffixCls: "scrollbar"
    }), {
      wrapSSR: u,
      hashId: m
    } = oe("ScrollBar", [ye], i);
    let r, v;
    const x = f(), a = f(), l = f(), T = f("0"), z = f("0"), C = f(), P = f(1), N = f(1), H = "GScrollbars", S = 4, M = L(() => {
      const t = {};
      return e.height && (t.height = I(e.height)), e.maxHeight && (t.maxHeight = I(e.maxHeight)), [e.wrapStyle, t];
    }), B = () => {
      var t;
      a.value && ((t = C.value) == null || t.handleScroll(a.value), s("scroll", {
        scrollTop: a.value.scrollTop,
        scrollLeft: a.value.scrollLeft
      }));
    };
    function $(t, d) {
      q(t) ? a.value.scrollTo(t) : w(t) && w(d) && a.value.scrollTo(t, d);
    }
    const o = (t) => {
      if (!w(t)) {
        console.warn(H, "value 必须为数字");
        return;
      }
      a.value.scrollTop = t;
    }, h = (t) => {
      if (!w(t)) {
        console.warn(H, "value 必须为数字");
        return;
      }
      a.value.scrollLeft = t;
    }, c = () => {
      if (!a.value)
        return;
      const t = a.value.offsetHeight - S, d = a.value.offsetWidth - S, O = t ** 2 / a.value.scrollHeight, R = d ** 2 / a.value.scrollWidth, k = Math.max(O, e.minSize), E = Math.max(R, e.minSize);
      P.value = O / (t - O) / (k / (t - k)), N.value = R / (d - R) / (E / (d - E)), z.value = k + S < t ? `${k}px` : "", T.value = E + S < d ? `${E}px` : "";
    };
    return A(() => e.noresize, (t) => {
      t ? (r == null || r(), v == null || v()) : ({
        stop: r
      } = D(l, c), v = W("resize", c));
    }, {
      immediate: !0
    }), A(() => e.noresize, (t) => {
      t ? (r == null || r(), v == null || v()) : ({
        stop: r
      } = D(l, c), v = W("resize", c));
    }, {
      immediate: !0
    }), A(() => [e.maxHeight, e.height], () => {
      e.native || j(() => {
        var t;
        c(), a.value && ((t = C.value) == null || t.handleScroll(a.value));
      });
    }), se({
      hashId: m,
      className: i,
      wrapElement: a,
      scrollbarElement: x
    }), te(() => {
      e.native || j(() => c());
    }), y({
      /** @description scrollbar wrap ref */
      wrapRef: a,
      /** @description update scrollbar state manually */
      update: c,
      /** @description scrolls to a particular set of coordinates */
      scrollTo: $,
      /** @description set distance to scroll top */
      setScrollTop: o,
      /** @description set distance to scroll left */
      setScrollLeft: h,
      /** @description handle scroll event */
      handleScroll: B
    }), () => {
      const t = e.tag;
      return u(b("div", {
        ref: x,
        class: `${i} ${m.value}`,
        style: {
          ...(g == null ? void 0 : g.style) || {}
        }
      }, [b("div", {
        ref: a,
        class: [m.value, e.wrapClass, `${i}-wrap`, e.native ? "" : `${i}-wrap-hidden-default`],
        style: M.value,
        onScroll: B
      }, [b(t, {
        ref: l,
        class: [`${i}-view`, e.viewClass, m.value],
        style: e.viewStyle
      }, {
        default: () => {
          var d;
          return [(d = n.default) == null ? void 0 : d.call(n)];
        }
      })]), !e.native && b(he, {
        ref: C,
        height: z.value,
        width: T.value,
        always: e.always,
        barStyle: e.barStyle,
        ratioX: N.value,
        ratioY: P.value
      }, null)]));
    };
  }
});
Se.inheritAttrs = !1;
export {
  Se as GScrollbars,
  Se as default,
  ne as scrollbarProps
};
